/*
** Module   : SOAPHeaderEntryImpl.java
** Abstract : Implementation for the SOAP-HEADER-ENTRY resource.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- --------------------------------Description-----------------------------------
** 001 CA  20130216 Created initial version.
*/

package com.goldencode.p2j.util;

/**
 * A class for implementing the SOAP-HEADER-ENTRY method and attributes.
 * TODO: add support only for NAME and PRIVATE-DATA attributes (without PREV-/NEXT-SIBLING)
 */
public class SOAPHeaderEntryImpl
extends HandleChain
implements SOAPHeaderEntry,
           SOAPEntity,
           CommonHandleChain
{
   /**
    * Gets the X-NODEREF object that refers to the XML underlying a SOAP-HEADER-ENTRYREF object or
    * SOAP-FAULT entry and sets it to the given handle..
    * 
    * @param    xNode
    *           The handle where the resource will be set.
    *           
    * @return   <code>true</code> if the operation was possible.
    */
   public logical getNode(handle xNode)
   {
      // TODO: implement this
      return new logical();
   }

   /**
    * Returns a LONGCHAR that contains the serialized form of the XML underlying the 
    * SOAP-HEADER-ENTRYREF or SOAP-FAULT entry.
    * 
    * @return   See above.
    */
   public longchar getSerialized()
   {
      // TODO: implement this
      return new longchar();
   }

   /**
    * Returns the value of the actor attribute for the SOAP-HEADER-ENTRYREF object as a URL. 
    * Identifies the recipient of a header element.
    * 
    * @return   See above.
    */
   public character getActor()
   {
      // TODO: implement this
      return new character();
   }

   /**
    * Indicates whether a SOAP-HEADER-ENTRYREF object is mandatory (TRUE) or optional (FALSE) for
    * the recipient to process.
    * 
    * @return   See above.
    */
   public logical isMustUnderstand()
   {
      // TODO: implement this
      return new logical();
   }

   /**
    * Deletes the XML underlying a SOAP-HEADER-ENTRYREF object, without deleting the object.
    * 
    * @return   <code>true</code> if the operation was possible.
    */
   public logical deleteHeaderEntry()
   {
      // TODO: implement this
      return new logical();
   }

   /**
    * Sets the ACTOR attribute for this SOAP-HEADER-ENTRY.
    *
    * @param    uri
    *           The URI of the SOAP actor.
    * 
    * @return   <code>true</code> if the operation was possible.
    */
   public logical setActor(character uri)
   {
      // TODO: implement this
      return new logical();
   }

   /**
    * Sets the ACTOR attribute for this SOAP-HEADER-ENTRY.
    *
    * @param    uri
    *           The URI of the SOAP actor.
    * 
    * @return   <code>true</code> if the operation was possible.
    */
   public logical setActor(String uri)
   {
      return setActor(new character(uri));
   }

   /**
    * Sets the MUST-UNDERSTAND attribute for this SOAP-HEADER-ENTRY.
    *
    * @param    val
    *           The new value of this attribute.
    * 
    * @return   <code>true</code> if the operation was possible.
    */
   public logical setMustUnderstand(logical val)
   {
      return setMustUnderstand(new logical(val));
   }

   /**
    * Sets the MUST-UNDERSTAND attribute for this SOAP-HEADER-ENTRY.
    *
    * @param    val
    *           The new value of this attribute.
    * 
    * @return   <code>true</code> if the operation was possible.
    */
   public logical setMustUnderstand(boolean val)
   {
      // TODO: implement this
      return new logical();
   }

   /**
    * Replaces the underlying XML of a SOAP-HEADER-ENTRYREF object with the DOM XML sub-tree 
    * rooted by the X-NODEREF object.
    *
    * @param    xNoderef
    *           A X-NODEREF variable that refers to the XML that will be set for the 
    *           SOAP-HEADER-ENTRYREF object.
    * 
    * @return   <code>true</code> if the operation was possible.
    */
   public logical setNode(handle xNoderef)
   {
      // TODO: implement this
      return new logical();
   }

   /**
    * Sets the SOAP-header-entryref object’s underlying XML from serialized XML.
    *
    * @param    xml
    *           A LONGCHAR variable that contains the XML that will become this 
    *           SOAP-HEADER-ENTRYREF object.
    * 
    * @return   <code>true</code> if the operation was possible.
    */
   public logical setSerialized(longchar xml)
   {
      // TODO: implement this
      return new logical();
   }
   
   /**
    * Reports if this object is valid for use.  
    *
    * @return   <code>true</code> if we are valid (can be used).
    */
   public boolean isValid()
   {
      // TODO: implement this
      return false;
   }
}
